-- This Source Code Form is subject to the terms of the bCDDL, v. 1.1.
-- If a copy of the bCDDL was not distributed with this
-- file, You can obtain one at http://beamng.com/bCDDL-1.1.txt

local M = {}
M.type = "auxiliary"

local htmlTexture = require("htmlTexture")

local screenMaterialName = nil
local htmlFilePath = nil
local textureWidth = 0
local textureHeight = 0
local textureFPS = 0

local function updateGFX(dt)
    -- No updates needed for static animation
end

local function init(jbeamData)
    screenMaterialName = jbeamData.screenMaterialName or "@skin_animated_emissive"
    htmlFilePath = jbeamData.htmlFilePath or "local://local/vehicles/common/car_skin_video.html"
    textureWidth = jbeamData.textureWidth or 1024
    textureHeight = jbeamData.textureHeight or 1024
    textureFPS = jbeamData.textureFPS or 30

    print("Creating HTML texture for car skin emissive:", htmlFilePath)

    data = {
        backgroundPath = jbeamData.backgroundPath,
    }

    htmlTexture.create(screenMaterialName, htmlFilePath, textureWidth, textureHeight, textureFPS, "automatic")
    htmlTexture.call(screenMaterialName, "init", data)
end

M.init = init
M.reset = nop -- Prevent re-initialization on reset
M.updateGFX = updateGFX

return M